/*
 * Copyright 2003, Nathan E. Moore
 *
 * This file is part of Menu.
 *
 * Menu is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Menu is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Menu; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#pragma once
#include "menusub.h"
#include <string>

class MenuAuto
	:public MenuSub
{
private:
	virtual void parse() = 0;
	void autocolumn(HWND hwnd);

protected:
	bool m_dirty;
	bool m_dynamic;

	MenuAuto(const std::wstring& txt, bool isdynamic)
		:MenuSub(txt),
		m_dirty(true),
		m_dynamic(isdynamic)
	{	}

	void postDisplay();

public:
	static bool autocolumns;

	virtual ~MenuAuto()
	{	}

	void preDisplay(HWND hwnd);

	void setDirty()
	{
		m_dirty = true;
		postDisplay();
	}
};
