/*
 * Copyright 2003, Nathan E. Moore
 *
 * This file is part of Menu.
 *
 * Menu is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Menu is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Menu; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#pragma once
#include "menuentry.h"
#include <lsapi.h>
#include <string>
#include <stdexcept>
#include <windows.h>

class MenuBang :
	public MenuEntry
{
private:
	std::string m_bang;
	std::string m_args;

protected:
	MenuBang(const std::wstring& txt, const std::string& bcomd, const std::string& arguments)
		:MenuEntry(txt),
		m_bang(bcomd),
		m_args(arguments)
	{	}
	
public:
	static MenuEntryPtr createMenuBang(const std::wstring& txt, const std::string& bcomd, const std::string& arguments)
	{
		MenuEntryPtr temp(new MenuBang(txt, bcomd, arguments));
		return temp;
	}

	virtual ~MenuBang()
	{	}

	// These methods are never used
	//wstring getBang() const 
	//{
	//	return m_bang;
	//}

	//void setBang(wstring &newbang)
	//{
	//	m_bang = newbang;
	//}

	//wstring getArgs() const
	//{
	//	return m_args;
	//}

	//void setArgs(wstring &newargs)
	//{
	//	m_args = newargs;
	//}

	void execute(HWND hwnd)
	{
		if (ParseBangCommand(hwnd, m_bang.c_str(), m_args.c_str()))
			throw std::runtime_error("ParseBangCommand Failed.");
	}
	
	bool displayContextMenu(HWND hwnd)
	{
		return false;
	}
};