/*
 * Copyright 2003, Nathan E. Moore
 *
 * This file is part of Menu.
 *
 * Menu is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Menu is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Menu; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#pragma once
#include "menuentry.h"
#include "idlist.h"
#include <string>
#include <boost/shared_ptr.hpp>

class MenuIdList;
typedef boost::shared_ptr<MenuIdList> MenuIdListPtr;

class MenuIdList 
	:public MenuEntry,
	public util::ItemIdList
{
protected:
	MenuIdList(const std::wstring& txt, util::ItemIdList& idlist)
		:MenuEntry(txt),
		util::ItemIdList(idlist)
	{	}

public:
	static MenuIdListPtr createMenuIdListSpecial(const std::wstring& txt, util::ItemIdList& idlist)
	{
		MenuIdListPtr temp(new MenuIdList(txt, idlist));
		return temp;
	}

	static MenuEntryPtr createMenuIdList(const std::wstring& txt, util::ItemIdList& idlist)
	{
		MenuEntryPtr temp(new MenuIdList(txt, idlist));
		return temp;
	}

	virtual ~MenuIdList()
	{	}

	bool displayContextMenu(HWND hwnd)
	{
		return util::ContextMenu::popupContextMenu(*this, hwnd);
	}

	void execute(HWND hwnd)
	{
		ItemIdList::execute(hwnd);
	}
};