/*
 * Copyright 2003, Nathan E. Moore
 *
 * This file is part of Menu.
 *
 * Menu is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Menu is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Menu; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "menutasks.h"
#include "menuwindow.h"
#include <windows.h>
#include <boost/scoped_array.hpp>

#ifndef WS_EX_NOACTIVATE
	#define WS_EX_NOACTIVATE 0x08000000L
#endif

BOOL MenuTasks::enumWindowsProc(HWND hwnd, LPARAM lparam)
{	
	// Validation
	LONG style = GetWindowLong(hwnd, GWL_STYLE);
	if ((style & WS_CHILD) == WS_CHILD || (style & WS_VISIBLE) != WS_VISIBLE)
		return TRUE;

	style = GetWindowLong(hwnd, GWL_EXSTYLE);
	if ((style & WS_EX_TOOLWINDOW) == WS_EX_TOOLWINDOW ||( (style & WS_EX_NOACTIVATE) == WS_EX_NOACTIVATE && (style & WS_EX_APPWINDOW) != WS_EX_APPWINDOW ))
		return TRUE;

	style = GetWindowLong(hwnd, GWL_HWNDPARENT);
	if (style != 0)
		return TRUE;

	// Creating a new menu Item;
	MenuTasks* psuedothis = reinterpret_cast<MenuTasks*>(lparam);
	
	int bufsize = GetWindowTextLength(hwnd) + 1;
	boost::scoped_array<wchar_t> buffer(new wchar_t[bufsize]);
	GetWindowText(hwnd, buffer.get(), bufsize);
	psuedothis->addItem(MenuWindow::createMenuWindow(std::wstring(buffer.get()), hwnd));
	
	return TRUE;
}