/*
 * Copyright 2003, Nathan E. Moore
 *
 * This file is part of Menu.
 *
 * Menu is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Menu is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Menu; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "menuwindow.h"
#include "globals.h"
#include "smarthmenu.h"

//void MenuWindow::execute(HWND hwnd)
//{
//	/* 
//		"SwitchToThisWindow"
//		1) Get MenuWindow::Hwnd's thread id
//		2) Attach Input
//		3) SetActiveWindow()
//		4) Detach input
//	*/
//
//	DWORD mythreadid = GetWindowThreadProcessId(hwnd, NULL);
//	DWORD threadid = GetWindowThreadProcessId(m_taskhwnd, NULL);
//	if (AttachThreadInput(mythreadid, threadid, TRUE) == 0)
//	{
//		onError("AttachThreadInput Failed");
//		return;
//	}
//
//	SetActiveWindow(m_taskhwnd);
//
//	if (AttachThreadInput(mythreadid, threadid, FALSE) == 0)
//		onError("AttachThreadInput Failed (detaching)");
//}

bool MenuWindow::displayContextMenu(HWND hwnd)
{
	// Known Problem: The PowerMenu Additions do not work
	// Although the winamp additions do, possibly an error in powermenu

	util::SmartHmenu sysmenu(GetSystemMenu(m_taskhwnd, FALSE));

	WINDOWPLACEMENT wp;
	ZeroMemory(&wp, sizeof(WINDOWPLACEMENT));
	wp.length = sizeof(WINDOWPLACEMENT);
	GetWindowPlacement(m_taskhwnd, &wp);

	EnableMenuItem(sysmenu, SC_RESTORE, MF_BYCOMMAND | (wp.showCmd != SW_SHOWNORMAL ? MF_ENABLED : MF_GRAYED));
	EnableMenuItem(sysmenu, SC_MOVE, MF_BYCOMMAND | (wp.showCmd == SW_SHOWNORMAL ? MF_ENABLED : MF_GRAYED));
	EnableMenuItem(sysmenu, SC_SIZE, MF_BYCOMMAND | (wp.showCmd == SW_SHOWNORMAL ? MF_ENABLED : MF_GRAYED));
	EnableMenuItem(sysmenu, SC_MINIMIZE, MF_BYCOMMAND | (wp.showCmd != SW_SHOWMINIMIZED ? MF_ENABLED : MF_GRAYED));
	EnableMenuItem(sysmenu, SC_MAXIMIZE, MF_BYCOMMAND | (wp.showCmd != SW_SHOWMAXIMIZED ? MF_ENABLED : MF_GRAYED));

	SendMessage(m_taskhwnd, WM_INITMENUPOPUP, (WPARAM) sysmenu.get(), MAKELPARAM(0, TRUE));
	SendMessage(m_taskhwnd, WM_INITMENU, (WPARAM) sysmenu.get(), 0);
    
	POINT pt;
	GetCursorPos(&pt);

	int cmd = TrackPopupMenu(sysmenu, TPM_RECURSE |TPM_RETURNCMD | TPM_RIGHTBUTTON, pt.x, pt.y, 0, hwnd, NULL);

	if (!cmd)
		return false;
	else if (cmd != SC_MINIMIZE && cmd != SC_CLOSE)
		execute(hwnd);
	PostMessage(m_taskhwnd, WM_SYSCOMMAND, (WPARAM) cmd, MAKELPARAM(pt.x, pt.y));
	return true;
}