/*
 * Copyright 2003, Nathan E. Moore
 *
 * This file is part of Menu.
 *
 * Menu is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Menu is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Menu; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#pragma once
#include "menuentry.h"
#include <string>
#include <windows.h>

class MenuWindow :
	public MenuEntry
{
private:
	HWND m_taskhwnd;	// Never need to be validated because this is dynamic menu item
	
protected:
	MenuWindow(std::wstring& txt, HWND handle)
		:MenuEntry(txt),
		m_taskhwnd(handle)
	{	}

public:
	static MenuEntryPtr createMenuWindow(std::wstring& txt, HWND handle)
	{
		MenuEntryPtr temp(new MenuWindow(txt, handle));
		return temp;
	}

	virtual ~MenuWindow()
	{	}

	// Executes Item 
	void execute(HWND hwnd)
	{
		SwitchToThisWindow(m_taskhwnd, FALSE);
	}

	bool displayContextMenu(HWND hwnd);
};