/*
 * Copyright 2003, Nathan E. Moore
 *
 * This file is part of Menu.
 *
 * Menu is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Menu is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Menu; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#pragma once
#include <windows.h>
#include <string>
#include <boost/shared_array.hpp>

#define WSTR2(x) L##x
#define WSTR(x) WSTR2(x)
#define MAKE_ERROR_MSG(x) makeErrorMsg(x, __FILE__, __LINE__)

#define MODULE_NAME_HIDDEN "Menu.dll"
#define HOTLIST_HIDDEN "Litestep"

// there is no good way to tie these values to the Version info resource
static const wchar_t* W_MODULE_NAME = WSTR(MODULE_NAME_HIDDEN);
static const char* MODULE_NAME      = MODULE_NAME_HIDDEN;
static const char* MODULE_VERSION   = "0.8";

// Default entry / header values
static const wchar_t* TASKS       = L"Tasks";
static const char* HOTLIST        = HOTLIST_HIDDEN;
static const wchar_t* W_HOTLIST   = WSTR(HOTLIST_HIDDEN);
static const wchar_t* REMOTEAMP   = L"Winamp Controls";

// Pulled from popupmaker.h
// What determins this value?
// Is this firm, or just a hope that some resourceful user doesn't write anything longer.
static const int MAX_RC_STRING = 256;

// Finds Work area of the Monitor on which pt lies
void getWorkArea(POINT* pt, RECT* prcWork);

std::string getWinErrorMsg();
std::string makeErrorMsg(std::string msg, const char* file, int line);
boost::shared_array<wchar_t> toUnicode(const char* astr);