/*
 * Copyright 2003, Nathan E. Moore
 *
 * This file is part of Menu.
 *
 * Menu is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Menu is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Menu; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#pragma once
#include "bangablemenu.h"
#include <vector>

// vector used to store a list of bang commands determined at runtime
typedef std::vector<BangMenuPtr> BangVector;

class Menu :
	public BangableMenu
{
private:
    BangVector m_banglist;
    	
	void windowProc(Message& message);
	void onGetRevId(Message& message);
	void onLMPopup(Message& message);
	void onLMHidePopup(Message& message);

public:
	Menu(HWND parentWnd);
	~Menu();

	void onBangCmd(const char* name, const char* args);
};
	
void onBangCmdFunction(HWND, const char *pszName, const char *pszArguments);

extern "C"
{
	__declspec( dllexport ) int initModuleEx(HWND parent, HINSTANCE dll, LPCSTR szPath);
	__declspec( dllexport ) void quitModule(HINSTANCE dllInst);
}